/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static Widget sample;
static GC gc;
static Colormap colormap;
static unsigned long pixel;
static unsigned long red = 0, green = 0, blue = 0;

/* ΥХå */
static void ChangeColorCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmScaleCallbackStruct *cb = (XmScaleCallbackStruct *)call_data;
    XColor color;

    /* ͤ򥻥å */
    switch ((int)client_data) {  /* ɤΥͤѤäΤ */
        case 0: red   = cb->value; break;  /* ֤Υ */
        case 1: green = cb->value; break;  /* ФΥ */
        case 2: blue  = cb->value; break;  /* ĤΥ */
    }
    /* ξ򥻥å */
    color.pixel = pixel;  /* ѹԥ (ͭ顼) */
    color.red   = red   * 256;  /* RGB ͤϰϤ 0 - 65535 */ 
    color.green = green * 256;  /* ϰϤ 0 - 255 ʤΤ */
    color.blue  = blue  * 256;  /* 256 ܤ RGB ͤȤ */
    color.flags = DoRed | DoGreen | DoBlue;  /* RGB Ǥѹ */

    /* ͤǿդ */
    if (XStoreColor(XtDisplay(w), colormap, &color) == 0) {
        fprintf(stderr, "Cannot allocate the new color\n");
        exit(1);
    }

    /* Υԥͤ򡤥ץ롦åȤطʤ */
    XtVaSetValues(sample, XmNbackground, color.pixel, NULL);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, control, scales[3];
    Arg al[20];
    int ac;
    int i;
    char wname[10];
    unsigned long plane;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    /* Xġ륭åȤ (ǥץ쥤򥪡ץ) */
    toplevel = XtAppInitialize(&app_context, "Changecolor", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ץɽ륦å */
    ac = 0;
    sample = XmCreateLabel(panel, "sample", al, ac);
    XtManageChild(sample);

    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    for (i = 0; i < 3; i++) {
        ac = 0;
        sprintf(wname, "scale%d", i);
        scales[i] = XmCreateScale(control, wname, al, ac);
        XtAddCallback(scales[i], XmNdragCallback, ChangeColorCB, i);
        XtAddCallback(scales[i], XmNvalueChangedCallback, ChangeColorCB, i);
    }
    XtManageChildren(scales, 3);

    /* ǥեȤΥ顼ޥåפ */
    colormap = DefaultColormapOfScreen(XtScreen(sample));
    /* 1ĤΥ顼ͭ */
    if (XAllocColorCells(XtDisplay(sample), colormap,
                         False, &plane, 0, &pixel, 1) == 0) {
        fprintf(stderr, "Cannot allocate color cell.\n");
        exit(1);
    }

    XtRealizeWidget(toplevel); /* ǥɥ */

    /* եåƥȤ° */
    gc = XCreateGC(XtDisplay(sample), XtWindow(sample), NULL, NULL);

    /* οꤷƤ */
    XtVaSetValues(sample,
                  XmNbackground, BlackPixelOfScreen(XtScreen(sample)), NULL);

    XtAppMainLoop(app_context);
}
